#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define N 2000
#define MIN (1.0E-20)

double A[N][N];

main()
{
	int i,j,k;
	double s;

	// inicialitzacio de A

	#pragma omp parallel private(i,j)
	{  
 	for (i=0;i<N;i++)
	       for (j=0;j<N;j++)
	             A[i][j] = 1.0*(N-i)*(N-j)/(N*N);
	}
 
          for (j=0;j<N;j++)
                  {
                    if (A[j][j] == 0) A[j][j] = MIN;
              	#pragma omp parallel for private(i,k)
		 for (i=j+1;i<N;i++)
                     {
                     A[i][j] /= A[j][j];
		     for (k=j+1;k<N;k++)
                      A[i][k] -= A[i][j]*A[j][k];
                     }
                   }

	
	  #pragma omp parallel for private(i,j) reduction(+ : s)                                                             
                {
		 for (i=0; i<N; i++)
                    for (j=0; j<N; j++)
                      s += A[i][j];
        	} 

  printf("Suma %lg \n ",s);
 }
                                 
